;------------------------------------------------------------------------------
;				Q[
;------------------------------------------------------------------------------
GameInit:
	lda	#$00
	sta	game_mode

	jsr	RamClear
	jsr	PPUInit
	jsr	APUInit

	lda	#$05
	sta	<max_sprite
	lda	#$FF
	sta	game_mode
;-------------------------------------- e평ݒ
	lda	#$70
	sta	chara.dotx
	lda	#$AF
	sta	chara.doty
	lda	#$01
	sta	chara.pattern
	sta	chara.exist
	lda	#$00
	sta	chara.color
	lda	#$05
	sta	chara.enagy
	
	jsr	DrawMap

	rts

;------------------------------------------------------------------------------
;			肳ďd
;------------------------------------------------------------------------------
DrawMap:
	lda	#$00
	sta	$2001

	lda	#$3F
	sta	$2006
	lda	#$00
	sta	$2006

	ldx	#$00
.load_pal:
	lda	pal_table, x
	sta	$2007
	inx
	cpx	#$20
	bne	.load_pal

	lda	#$20
	sta	$2006
	lda	#$00
	sta	$2006

	ldx	#$00
.write1:
	lda	map_table, x
	sta	$2007
	inx
	bne	.write1

	ldx	#$00
.write2:
	lda	map_table + $100, x
	sta	$2007
	inx
	bne	.write2

	ldx	#$00
.write3:
	lda	map_table + $200, x
	sta	$2007
	inx
	bne	.write3

	lda	#$00
	ldx	#$00
	ldy	#$19
	jsr	SetVramAddress
	stx	$2006
	sty	$2006

	ldx	#$00
.write4:
	lda	window_table, x
	sta	$2007
	inx
	cpx	#$C0
	bne	.write4	

	rts
	
map_table:
	.INCBIN		"data\map.bin"
window_table:
	.INCBIN		"data\window.bin"
pal_table:
	.DB	$0D, $00, $10, $30
	.DB	$0D, $00, $10, $30
	.DB	$0D, $00, $10, $30
	.DB	$0D, $00, $10, $30

	.DB	$0D, $2D, $21, $30
	.DB	$0D, $2D, $25, $28
	.DB	$0D, $2D, $2A, $10
	.DB	$0D, $16, $37, $30
;------------------------------------------------------------------------------
;			肳ďd
;------------------------------------------------------------------------------
Delay:
	txa
	pha

	ldx	#$00
.loop:
	nop
	dex
	bne	.loop

	pla
	tax

	rts

RamClear:
	lda	#$00
	ldx	#$00
.clear_zerox:
	sta	$00, x
	inx
	bne	.clear_zerox

	ldx	#$02
	ldy	#$00
	stx	<point1 + 1
	sty	<point1

	lda	#$00
	ldx	#$06
.clear_x:
	ldy	#$00
.clear_y:
	sta	[point1], y
	iny
	bne	.clear_y

	inc	<point1 + 1
	dex
	bne	.clear_x

	rts
