;------------------------------------------------------------------------------
;			Q[̍XVC
;------------------------------------------------------------------------------
GameUpdate:
;-------------------------------------- @̂̏ԕω
	ldx	#$01
.locat_flag_update:
	lda	chara.exist, x
	sub	#$02			; Ԃ2ȏ̏ꍇ
	bcc	.locat_not_bomb

	lda	<screen.flip
	bne	.locat_not_bomb

	lda	chara.exist, x
	cmp	#$08
	beq	.locate_death

	inc	chara.exist, x
	inc	chara.pattern, x
	jmp	.locat_not_bomb
.locate_death:
	lda	#$00
	sta	chara.exist, x
	.locat_not_bomb:
	inx
	cpx	<max_sprite
	bne	.locat_flag_update
;-------------------------------------- vC[̒eړ
	lda	chara.exist + $10
	beq	.wepon_sety_play

	lda	chara.doty + $10
	sub	#$08
	php
	sta	chara.doty + $10
	plp
	bcs	.wepon_sety_play
.wepon_reset_play:
	lda	#$00
	sta	chara.exist + $10
.wepon_sety_play:
;-------------------------------------- bot̒e
	ldx	<max_sprite
.wepon_shot_cpu:
	lda	chara.exist, x
	beq	.wepon_shot_cpu_end
	
	lda	chara.type, x		; @̂̎ނQȏȂ甭
	sub	#$02
	bcc	.wepon_shot_cpu_end
	
	lda	chara.exist + $10, x
	bne	.wepon_shot_cpu_end

	dec	chara.shotblank, x
	bne	.wepon_shot_cpu_end
	
	lda	chara.dotx, x
	sta	chara.dotx + $10, x
	lda	chara.doty, x
	sta	chara.doty + $10, x
	lda	#$01
	sta	chara.exist + $10, x
	lda	#$08
	sta	chara.pattern + $10, x
	lda	#$00
	sta	chara.color + $10, x
	lda	#$60
	sta	chara.shotblank, x
	
.wepon_shot_cpu_end:
	dex
	bne	.wepon_shot_cpu
;-------------------------------------- bot̒eړ
	ldx	<max_sprite
.wepon_move_cpu:
	lda	chara.exist + $10, x
	beq	.wepon_reset_cpu

	lda	chara.doty + $10, x
	add	#$04
	php
	sta	chara.doty + $10, x
	plp
	bcc	.wepon_sety_cpu
.wepon_reset_cpu:
	lda	#$00
	sta	chara.exist + $10, x
.wepon_sety_cpu:
	dex
	bne	.wepon_move_cpu
;-------------------------------------- vC[̒e̓蔻
	ldx	<max_sprite
.check_hit_play:
	lda	chara.exist + $10
	beq	.check_hit_play_end

	ldy	chara.exist, x
	dey
	beq	.check_hit_play_main
	jmp	.check_hit_play_end

.check_hit_play_main:
	lda	chara.dotx + $10
	sub	#$08
	sub	chara.dotx, x
	bcs	.check_hit_play_end		; X̍`FbN

	lda	chara.dotx + $10
	add	#$08
	sub	chara.dotx, x
	bcc	.check_hit_play_end		; X̉E`FbN

	lda	chara.doty + $10
	sub	#$08
	sub	chara.doty, x
	bcs	.check_hit_play_end		; Y̏㑤`FbN

	lda	chara.doty + $10
	add	#$08
	sub	chara.doty, x
	bcc	.check_hit_play_end		; Ỷ`FbN
	
.hit_play_to_cpu:
	lda	#%00001111			;
	sta	$400C
	lda	#%10001000
	sta	$400E
	lda	#%01111001
	sta	$400F

	lda	#$00
	sta	chara.exist + $10

	dec	chara.enagy, x
	bne	.check_hit_play_end
	
	jsr	DefeatCpu
.check_hit_play_end:
	dex
	bne	.check_hit_play
;-------------------------------------- bot̋@̓蔻
	ldx	chara.exist
	beq	.check_ultra_mode

	ldx	<max_sprite
.check_hit_cpu:
	ldy	chara.exist, x
	dey
	bne	.check_hit_cpu_end

	lda	chara.dotx, x
	sub	#$0C
	sub	chara.dotx
	bcs	.check_hit_cpu_end		; X̍`FbN

	lda	chara.dotx, x
	add	#$0C
	sub	chara.dotx
	bcc	.check_hit_cpu_end		; X̉E`FbN

	lda	chara.doty, x
	sub	#$0C
	sub	chara.doty
	bcs	.check_hit_cpu_end		; Y̏㑤`FbN
	
	lda	chara.doty, x
	add	#$0C
	sub	chara.doty
	bcc	.check_hit_cpu_end		; Y̏㑤`FbN
.hit_cpu_to_play:
	lda	#$00				; 1bԖGԂɂ
	sta	chara.exist
	lda	#$60
	sta	<ultra_count

	lda	#%00001111			;
	sta	$400C
	lda	#%10001000
	sta	$400E
	lda	#%01111001
	sta	$400F

	dec	chara.enagy
	bne	.update_ultra_mode
	
	lda	#$FF
	sta	game_mode
	jmp	.end
.check_hit_cpu_end:
	dex
	bne	.check_hit_cpu
;-------------------------------------- bot̒e̓蔻
.check_ultra_mode:
	ldx	chara.exist
	beq	.update_ultra_mode

	ldx	<max_sprite
.check_hit_cpu_wepon:
	ldy	chara.exist + $10, x
	dey
	bne	.check_hit_cpu_wepon_end

	lda	chara.dotx + $10, x
	sub	#$08
	sub	chara.dotx
	bcs	.check_hit_cpu_wepon_end	; X̍`FbN

	lda	chara.dotx + $10, x
	add	#$08
	sub	chara.dotx
	bcc	.check_hit_cpu_wepon_end	; X̉E`FbN

	lda	chara.doty + $10, x
	sub	#$08
	sub	chara.doty
	bcs	.check_hit_cpu_wepon_end	; Y̏㑤`FbN
	
	lda	chara.doty + $10, x
	add	#$08
	sub	chara.doty
	bcc	.check_hit_cpu_wepon_end	; Y̏㑤`FbN
.hit_cpu_to_play_wepon:
	lda	#$00				; 1bԖGԂɂ
	sta	chara.exist
	sta	chara.exist + $10, x
	lda	#$40
	sta	<ultra_count

	lda	#%00001111			;
	sta	$400C
	lda	#%10001000
	sta	$400E
	lda	#%01111001
	sta	$400F

	dec	chara.enagy
	bne	.update_ultra_mode
	
	lda	#$FF
	sta	game_mode
	jmp	.end
.check_hit_cpu_wepon_end:
	dex
	bne	.check_hit_cpu_wepon
;--------------------------------------- GԂJEg
.update_ultra_mode:
	ldx	chara.exist
	bne	.end
	
	dec	<ultra_count
	bne	.end
	
	lda	#$01
	sta	chara.exist
.end:

	rts
;------------------------------------------------------------------------------
;				
;------------------------------------------------------------------------------
DrawEnagy:
	lda	#$00
	ldx	#$07
	ldy	#$1B
	jsr	SetVramAddress
	stx	$2006
	sty	$2006

	ldx	chara.enagy
	beq	.write_empty_start
.write_enagy:
	lda	#$AD
	sta	$2007
	dex
	bne	.write_enagy

.write_empty_start:
	ldx	chara.enagy
.write_empty:
	lda	#$80
	sta	$2007
	inx
	cpx	#$06
	bne	.write_empty

	rts
	
	
DefeatCpu:
	lda	#$02
	sta	chara.exist, x
	lda	#$09
	sta	chara.pattern, x
	lda	#$03
	sta	chara.color, x
	lda	chara.score, x
	sta	<reg1
	ldx	score + 1
	ldy	score
	addw	#$00, <reg1
	stx	score + 1
	sty	score
	
	lda	#%00000000			; 
	sta	$4000
	lda	#%00000000
	sta	$4001
	lda	#%01001111
	sta	$4002
	lda	#%00001001
	sta	$4003

	rts

LevelUp:
	lda	score + 1
	cmp	#$40
	beq	.level9
	cmp	#$20
	beq	.level8
	cmp	#$14
	beq	.level7
	cmp	#$0C
	beq	.level6
	cmp	#$06
	beq	.level5
	cmp	#$04
	beq	.level4
	cmp	#$02
	beq	.level3
	cmp	#$01
	beq	.level2
	jmp	.end
.level9:
	lda	#$0F
	sta	max_sprite
	lda	#$03
	sta	max_valiation
	jmp	.end
.level8:
	lda	#$0B
	sta	max_sprite
	lda	#$03
	sta	max_valiation
	jmp	.end
.level7:
	lda	#$09
	sta	max_sprite
	lda	#$03
	sta	max_valiation
	jmp	.end
.level6:
	lda	#$08
	sta	max_sprite
	lda	#$03
	sta	max_valiation
	jmp	.end
.level5:
	lda	#$07
	sta	max_sprite
	lda	#$03
	sta	max_valiation
	jmp	.end
.level4:
	lda	#$06
	sta	max_sprite
	lda	#$03
	sta	max_valiation
	jmp	.end
.level3:
	lda	#$05
	sta	max_sprite
	lda	#$02
	sta	max_valiation
	jmp	.end
.level2:
	lda	#$05
	sta	max_sprite
	lda	#$01
	sta	max_valiation
	jmp	.end
.end:

	rts
