;------------------------------------------------------------------------------
;		SẴXvCgDMA_SPRAM֏
;------------------------------------------------------------------------------
DrawMapSprite:
	lda	<screen.flip
	bne	.type2
	jsr	DrawMapSprite1
	rts

.type2:
	jsr	DrawMapSprite2

	rts
;------------------------------------------------------------------------------
;			XvCgDMA_SPRAM֏1
;------------------------------------------------------------------------------
DrawMapSprite1:
	ldx	#$00
.write:
	txa
	pha

	lda	chara.exist, x
	bne	.normal_write

	jsr	DrawEmptySprite
	jmp	.write_end

.normal_write:
	lda	chara.dotx, x
	sta	<reg1
	lda	chara.doty, x
	sta	<reg2
	lda	chara.pattern, x
	sta	<reg3
	lda	chara.color, x
	sta	<reg4
	jsr	DrawSprite16	
	
.write_end:
	pla
	tax
	inx
	cpx	#$20
	bne	.write

	rts
;------------------------------------------------------------------------------
;			XvCgDMA_SPRAM֏2
;------------------------------------------------------------------------------
DrawMapSprite2:
	ldx	#$00
	lda	chara.dotx
	sta	<reg1
	lda	chara.doty
	sta	<reg2
	lda	chara.pattern
	sta	<reg3
	lda	chara.color
	sta	<reg4
	jsr	DrawSprite16

	ldx	#$01
	ldy	#$1F
.write:
	txa
	pha

	lda	chara.exist, y
	bne	.normal_write

	jsr	DrawEmptySprite
	jmp	.write_end
.normal_write:
	lda	chara.dotx, y
	sta	<reg1
	lda	chara.doty, y
	sta	<reg2
	lda	chara.pattern, y
	sta	<reg3
	lda	chara.color, y
	sta	<reg4
	jsr	DrawSprite16

.write_end:
	pla
	tax
	inx
	dey
	bne	.write

	rts
;------------------------------------------------------------------------------
;			16x16XvCg
; input		x : XvCg̈ʒu
;		r1: XW
;		r2: YW
;		r3: p^[
;		r4: F⑮
;------------------------------------------------------------------------------
DrawSprite16:
	txa
	asl	a
	asl	a
	asl	a
	tax
;---------------------------- p^[
	lda	<reg3
	asl	a
	asl	a
	add	#$01
	sta	sp_ram + 1, x
	add	#$02
	sta	sp_ram + 5, x
;---------------------------- 
	lda	<reg4
	sta	sp_ram + 2, x
	sta	sp_ram + 6, x
;---------------------------- XW
	lda	<reg1
	sta	sp_ram + 3, x
	add	#$08
	sta	sp_ram + 7, x
;---------------------------- YW
	lda	<reg2
	sta	sp_ram + 0, x
	sta	sp_ram + 4, x

	rts

DrawEmptySprite:
	txa
	asl	a
	asl	a
	asl	a
	tax

	lda	#$00
	sta	sp_ram + 0, x
	sta	sp_ram + 1, x
	sta	sp_ram + 2, x
	sta	sp_ram + 3, x
	sta	sp_ram + 4, x
	sta	sp_ram + 5, x
	sta	sp_ram + 6, x
	sta	sp_ram + 7, x

	rts
