;------------------------------------------------------------------------------
;				RESET 荞
;------------------------------------------------------------------------------
RESET:
	jsr	GameInit		; Q[̏

	lda	#$00
	sta	game_mode
;-------------------------------------- C[`
.main_loop:
	ldx	game_mode
	inx
	beq	.end
	
	jsr	InputUpdate
	jsr	CPUUpdate
	jsr	GameUpdate
	jsr	LevelUp

	jsr	DrawMapSprite
	lda	<screen.flip
	eor	#$01
	sta	<screen.flip

	lda	#$05
	ldx	score + 1
	ldy	score
	jsr	IntToString

	jsr	Refresh
	jsr	DrawEnagy
;--------------------------------------	XRA̕`
	lda	#$00
	ldx	#$13
	ldy	#$1B
	jsr	SetVramAddress
	stx	$2006
	sty	$2006
	
	ldx	#$00
.write_score:
	lda	tb_string_table, x
	sta	$2007
	inx
	cpx	#$05
	bne	.write_score
	lda	#$89
	sta	$2007

	jsr	SetScroll
	
	lda	#$02
	sta	$4014

	jmp	.main_loop
;--------------------------------------
.end:
	jsr	Refresh

	lda	#$00
	ldx	#$0B
	ldy	#$0D
	jsr	SetVramAddress
	stx	$2006
	sty	$2006
	
	lda	<screen.flag
	sta	$2000
	
	ldx	#$00
.go_write:
	
	lda	game_over_table, x
	sta	$2007
	inx
	cpx	#$09
	bne	.go_write
	
	jsr	SetScroll
.end_loop:
	jmp	.end_loop

	rti

game_over_table:
	.DB	$99, $93, $9F, $97, $00, $A1, $A8, $97, $A4

